Magellan Linux

Diff of /branches/mage-next/src/smage2.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

trunk/mage/usr/lib/mage/smage2.sh revision 195 by niro, Sat Aug 20 15:51:14 2005 UTC branches/mage-next/src/smage2.in revision 2806 by niro, Tue Sep 2 13:55:19 2014 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.26 2005-08-20 15:51:14 niro Exp $  
8    
 #01.10.2004  
 # added ccache support  
 # added distcc support  
9    
10  ## setup ##  # set default variables
11  PKGSUFFIX="mpk"  : ${MAGERC="@@SYSCONFDIR@@/mage.rc"}
12  SMAGENAME="$1"  : ${MLIBDIR="@@MAGELIBDIR@@"}
 SMAGESUFFIX="smage2"  
 #SOURCEDIR="/bootstrap/sources"  
 #SMAGESCRIPTSDIR="/bootstrap/smage2-install-scripts"  
 #SMAGE2RSYNC="rsync://192.168.0.2/smage2-scripts"  
 MLIBDIR=/usr/lib/mage  
 SMAGEVERSION="$( < ${MLIBDIR}/version)"  
13    
14  # export default C locale  # export default C locale
15  export LC_ALL=C  export LC_ALL=C
16    
17  source /etc/mage.rc  # first of all include common functions
18    source ${MLIBDIR}/common.functions.sh || exit 1
19  showversion() {  source @@SYSCONFDIR@@/mage.rc.global || die "@@SYSCONFDIR@@/mage.rc.global missing."
20   echo -en "Magellan Source Install v${SMAGEVERSION} "  source ${MAGERC} || die "${MAGERC} missing."
21   echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  source ${MLIBDIR}/mage4.functions.sh || die "${MLIBDIR}/mage4.functions.sh missing."
22  }  source ${MLIBDIR}/smage2.functions.sh || die "${MLIBDIR}/smage2.functions.sh missing."
   
 die() {  
  xtitleclean  
  echo "SMAGE failed: $@"  
  exit 1  
 }  
   
 xtitle() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
   
 xtitleclean() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2() {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync \  
  --recursive \  
  --links \  
  --perms \  
  --times \  
  --devices \  
  --timeout=600 \  
  --verbose \  
  --compress \  
  --progress \  
  --stats \  
  --delete \  
  --delete-after \  
  ${i} ${SMAGESCRIPTSDIR}  
   
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
   
  done  
   
  #clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # $1 filename  
 get_db_md5_sum() {  
  local DB_FILE  
  local MD5_FILE  
  local i  
   
  DB_ENTRY="$(basename $1)"  
  MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"  
   
  i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"  
   
  echo "${i}"  
 }  
   
 download_sources() {  
   
  [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0  
   
  local EOA=${#SRC_URI[*]}  
  local my_SRC_URI  
  local my_SRC_URI_DEST  
  local my_SRC_URI_MIRROR  
  local my_SOURCEDIR  
  local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"  
  local FETCHING  
  local i mirror  
   
   
  #install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
   
  # check if FETCHING is needed  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )  
  if [[ $? == 0 ]]  
  then  
  # md5's ok, not fetching needed  
  FETCHING=false  
  else  
  FETCHING=true  
  fi  
   
  for ((i=0; i < EOA; i++))  
  do  
  # url to file  
  my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"  
   
  # subdir in sources dir; the my_SRCI_URI file goes to there  
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
   
  # if an mirrored file than replace first the mirror uri  
  if [ -n "$(echo ${my_SRC_URI} | grep 'mirror://')" ]  
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
23    
24   #echo "DEBUG: ${MY_SRC_URI}"  # export default path
25   if [[ ${FETCHING} == true ]]  export PATH="${PATH}:${MLIBDIR}"
  then  
  echo "==> fetching ${my_SRC_URI_MIRROR}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  #echo "DEBUG: ${SRC_URI[${i}]}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI}"  
 # only needed to run through a list of mirrors  
 # if [ "$?" == "0" ]  
 # then  
 # break  
 # else  
 # continue  
 # fi  
  fi  
  fi  
   
  # unset them to be shure  
  unset my_SRC_URI  
  unset my_SRC_URI_DEST  
  unset my_SRC_URI_MIRROR  
  unset my_SOURCEDIR  
  done  
26    
27   # recheck md5 sums  print_usage()
28    {
29     echo "Usage: $(basename $0) [option] pkgname ..."
30     echo "Options:"
31     echo "--smage"
32     echo "--src-tarball"
33     echo "--calc"
34     echo "--update"
35     echo "--download"
36     echo "--regen"
37     echo "--create-src-tarball"
38     echo "--resume"
39   echo   echo
40   echo ">== Checking MD5 sums:"   echo "Environment variables::"
41   ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"   echo " NOCOLORS=true $(basename $0) [src]install PACKAGE"
42     echo " Disables all colors in the messages."
43   echo   echo
   
  # not needed anymore  
  unset SRC_URI  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_prepare() {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_compile() {  
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_install() {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
44  }  }
45    
46  mconfigure() {  # very basic getops
47   if [ -x ./configure ]  for i in $*
48   then  do
49   ./configure \   case $1 in
50   --prefix=/usr \   --smage|*.${SMAGESUFFIX}) shift; SMAGENAME="$1" ;;
51   --host=${CHOST} \   --src-tarball) shift; SRCPKGTARBALL="$1" ;;
52   --mandir=/usr/share/man \   --calc) shift; SMAGENAME="$1" ;;
53   --infodir=/usr/share/info \   --update) ;;
54   --datadir=/usr/share \   --download) shift; SMAGENAME="$1" ;;
55   --sysconfdir=/etc \   --regen) shift; SMAGENAME="$1" ;;
56   --localstatedir=/var/lib \   --create-src-tarball) shift; SMAGENAME="$1" ;;
57   "$@" || die "mconfigure failed"   --resume) ;;
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
   
 minstall() {  
  if [ -f ./[mM]akefile -o -f ./GNUmakefile ] ; then  
  make prefix=${BINDIR}/usr \  
  datadir=${BINDIR}/usr/share \  
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
   
 mmake() {  
  make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  
 }  
   
 munpack() {  
  local SRCFILE  
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [ -z "$2" ]  
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  tbz2)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
58   esac   esac
59  }   shift
60    done
 mpatch() {  
  local PATCHOPTS  
  local PATCHFILE  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
   
 minstalldocs() {  
  local docfiles  
   
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for i in ${docfiles}  
  do  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  done  
 }  
   
 mstriplibs() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 mstripbins() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 sminclude() {  
  local i  
   
  if [[ -n "$@" ]]  
  then  
  for i in $@  
  do  
  echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"  
  source ${SMAGESCRIPTSDIR}/include/${i}.sminc  
  done  
  echo  
  fi  
 }  
   
 setup_distcc_environment(){  
  if [ -x /usr/bin/distcc ]  
  then  
  echo "Using DistCC for compilation ..."  
  export PATH=/usr/lib/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  #export distcc as compiler  
 # export CC="distcc"  
 # export CXX=distcc  
   
  export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  
   
   
  #ccache + distcc together  
  if [ "${SMAGE_USE_CCACHE}" == "true" ]  
  then  
  if [ -x /usr/bin/ccache ]  
  then  
  echo "Preparing DistCC to work together with CCache ..."  
  #export CCACHE_PREFIX="distcc" || die "distcc: could not set ccach_prefix"  
 # export CC="ccache distcc"  
 # export CXX="ccache distcc"  
  fi  
  fi  
   
  #creating distcc tempdir  
  install -o distcc -g daemon -d ${DISTCC_DIR}  
  chmod 1777 ${DISTCC_DIR}  
  fi  
 }  
   
 setup_ccache_environment(){  
  if [ -x /usr/bin/ccache ]  
  then  
  echo "Using CCache for compilation ..."  
  export PATH=/usr/lib/ccache/bin:${PATH} || die "ccache: could not export new $PATH"  
  #unset CC CXX  
  fi  
 }  
   
   
 # fixes given dependencies to match a MAGE_TARGET  
 # fix_mage_deps target s/depend  
 fix_mage_deps() {  
  local target="$1"  
  local depend="$2"  
  local NDEPEND  
  local sym dep cat pver pname  
   
  # deps and provides are special  
  # they must be fixed to match the target  
   
  # run this only if target and depend is not empty  
  if [ -n "${target}" ] && [ -n "${depend}" ]  
  then  
  # fix DEPEND  
  while read sym dep  
  do  
  cat="$(dirname ${dep})"  
  # abort on virtual  
  [[ ${cat} = virtual ]] && continue  
   
  # fix pver to target-pver  
  # to get pname-target-pver  
   
  # doing it backwards !  
  pver="${dep##*-}"  
  pname=$(basename ${dep/-${pver}/})  
   
  # do not add empty lines  
  if [ -z "${NDEPEND}" ]  
  then  
  NDEPEND="${sym} ${cat}/${pname}-${target}-${pver}"  
  else  
  NDEPEND="${NDEPEND}  
  ${sym} ${cat}/${pname}-${target}-${pver}"  
  fi  
   
  unset cat pname pver  
  done << EOF  
 ${depend}  
 EOF  
  # set NDEPEND to DEPEND  
  depend="${NDEPEND}"  
  fi  
   
  echo "${depend}"  
 }  
   
 # build_mage_script(): helper functions for regen_mage_tree()  
 # generates an mage file with given information in smage file  
 # needs at least:  
 #   PNAME                 name of pkg  
 #   PVER                  version  
 #   PBUILD                revision  
 #   PCATEGORIE            categorie of the pkg  
 #   STATE                 state of pkg stable|unstable|old  
 #   DESCRIPTION           va short description (opt)  
 #   HOMEPAGE              homepage (opt)  
 #   DEPEND                runtime dependencies (opt)  
 #   SDEPEND               add. needed deps to build the pkg (opt)  
 #   PROVIDE               provides a virtual (opt)  
 #  
 # special tags:  
 #   PKGTYPE               type of pkg  
 #   INHERITS              which functions get included  
 #   SPECIAL_FUNCTIONS     special functions wich should also be added  
 #                         warning: they get killed before the build starts !  
 #  
 #   MAGE_TREE_DEST        target destination of the generated tree  
 #   REGEN_MAGE_TREE       set to 'true' to enable this  
 #  
 # gets called with build_mage_script target  
 build_mage_script()  
 {  
  local magefile  
  local dest  
  local target  
  local sym  
  local depname  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
   
  # determinate which suffix this mage file should get, if any  
  [ -n "$1" ] && target="-$1"  
   
  # name of magefile  
  magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"  
   
  # destination to magefile  
  dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${target}/${magefile}"  
   
  # show what we are doing  
  echo "Generating Mage file:"  
  echo "  ${dest}"  
   
  install -d "$(dirname ${dest})"  
  # now build the mage file  
  > ${dest}  
   
  # header  
  echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.26 2005-08-20 15:51:14 niro Exp $' >> ${dest}  
  echo  >> ${dest}  
   
  # pgkname and state  
  echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}  
  echo "STATE=\"${STATE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # description and homepage  
  echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}  
  echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # special tags  
  echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}  
  if [ -n "${INHERITS}" ]  
  then  
  echo -n "minclude"  >> ${dest}  
  local i  
  for i in ${INHERITS}  
  do  
  echo -n " ${i}"  >> ${dest}  
  done  
  echo  >> ${dest}  
  fi  
  echo >> ${dest}  
   
  # deps and provides  
  echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}  
  echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}  
  echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # add special functions  
  if [ -n "${SPECIAL_FUNCTIONS}" ]  
  then  
  local i  
  for i in ${SPECIAL_FUNCTIONS}  
  do  
  # add to mage (quotes needed !)  
  typeset -f "${i}" >> ${dest}  
  # unset to be safe (quotes needed !)  
  #unset "${i}" <-- later to get every target built  
  done  
  fi  
   
  # add special vars  
  if [ -n "${SPECIAL_VARS}" ]  
  then  
  local i  
  for i in ${SPECIAL_VARS}  
  do  
  # being tricky here :)  
  echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}  
  done  
  fi  
   
  # pre|post-install|removes  
  typeset -f preinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f postinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f preremove >> ${dest}  
  echo  >> ${dest}  
  typeset -f postremove >> ${dest}  
  echo  >> ${dest}  
 }  
61    
62  regen_mage_tree()  ## setup ##
63  {  SMAGENAME="$1"
  local i  
   
  # build them only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  # run it without targets  
  if [ -z "${MAGE_TARGETS}" ]  
  then  
  echo  
  build_mage_script  
  echo  
  else  
   
  # build for each target an mage file  
  # run it with several targets  
  for i in ${MAGE_TARGETS}  
  do  
  echo  
  build_mage_script "${i}"  
  echo  
  done  
  fi  
  fi  
64    
65   # now unset all uneeded vars to be safe  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
66   # unset PKGNAME <-- don't do that; smage needs this var  if [[ -n ${MROOT} ]]
67   # unset to be safe (quotes needed !)  then
68   for i in ${SPECIAL_FUNCTIONS}   export PKGDIR=${MROOT}/${PKGDIR}
69   do   export BUILDDIR=${MROOT}/${BUILDDIR}
70   unset "${i}"   export BINDIR=${MROOT}/${BINDIR}
71   done  fi
  unset SPECIAL_FUNCTIONS  
  for i in ${SPECIAL_VARS}  
  do  
  unset "${i}"  
  done  
  unset SPECIAL_VARS  
  unset STATE  
  unset DESCRIPTION  
  unset HOMEPAGE  
  unset PKGTYPE  
  unset INHERITS  
  unset DEPEND  
  unset SDEPEND  
  unset PROVIDE  
  unset preinstall  
  unset postinstall  
  unset preremove  
  unset postremove  
 }  
72    
73  # print out our version  # print out our version
74  showversion  showversion
75  echo  echo
76    
77  if [ -z "$1" ]  if [[ -z ${SMAGENAME} ]]
78  then  then
79   echo "No .smage2 file given. Exiting."   echo "No .smage2 file given. Exiting."
80   echo   echo
81   exit 1   exit 1
82  fi  fi
83    
84    # load supported mage features
85    load_mage_features
86    
87  # updating smage2-scripts  # updating smage2-scripts
88  if [ "$1" == "update" ]  if [[ $1 = update ]]
89  then  then
90   if [ ! -d ${SOURCEDIR} ]   if [ ! -d ${SOURCEDIR} ]
91   then   then
# Line 652  then Line 96  then
96  fi  fi
97    
98  # creates md5sums for smages to given dir  # creates md5sums for smages to given dir
99  if [ "$1" == "calcmd5" ]  if [[ $1 = calcmd5 ]]
100  then  then
101   if [ $# -ge 3 ]   if [ $# -ge 2 ]
102   then   then
103   SMAGENAME="$2"   SMAGENAME="$2"
104   MD5DIR="$3"   MD5DIR="$3"
105   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
106    
107     smagesource ${SMAGENAME} || die "download source failed"
108    
109   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
110   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 704  then Line 150  then
150   unset my_SRC_URI_MIRROR   unset my_SRC_URI_MIRROR
151   unset my_SOURCEDIR   unset my_SOURCEDIR
152   done   done
153    
154   echo   echo
155   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."
156   echo   echo
157   else   else
158   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
159   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
160   echo   echo
161   echo   echo
162   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
163   echo   echo
164   exit 1   exit 1
165   fi   fi
166    
167   exit 0   exit 0
168  fi  fi
169    
# Line 732  then Line 178  then
178   # get smage   # get smage
179   SMAGENAME="$2"   SMAGENAME="$2"
180   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
181   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
182    
183   download_sources   download_sources
184   exit 0   exit 0
185  fi  fi
186    
187  if [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ]  # regen-mage-tree
188    if [ "$1" == "only-regen-tree" -a -n "$2" ]
189  then  then
190   die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."   # set correct SMAGENAME
191  fi   SMAGENAME="$2"
192     MD5DIR="$(dirname ${SMAGENAME})/md5"
193     smagesource ${SMAGENAME} || die "regen: smage2 not found"
194    
195  if [ -z "`basename ${SMAGENAME}|grep .${SMAGESUFFIX}`" ]   regen_mage_tree
 then  
  die "File '`basename ${SMAGENAME}`' is not a sMage v${SMAGEVERSION} file. Aborting."  
 fi  
196    
197  if [ -z "${SOURCEDIR}" ]   # build several subpackages
198  then   if [[ -n ${SPLIT_PACKAGES} ]]
199   die "\$SOURCEDIR not found. Please setup your mage.rc correctly."   then
200  fi   split_save_variables
201     for subpackage in ${SPLIT_PACKAGES}
202     do
203     # get the right variables for the split
204     export PNAME="${subpackage}"
205     split_info_${subpackage}
206     # fix PCATEGORIE -> PCAT
207     if [[ ! -z ${PCATEGORIE} ]]
208     then
209     PCAT="${PCATEGORIE}"
210     unset PCATEGORIE
211     fi
212     # build md5sum for existing packages
213     generate_package_md5sum \
214     --pcat "${PCAT}" \
215     --pname "${PNAME}" \
216     --pver "${PVER}" \
217     --pbuild "${PBUILD}" \
218     --parch "${ARCH}"
219     # restore smage environment
220     split_restore_variables
221     done
222     # unset all saved smage variables
223     split_unset_variables
224    
225  if [ -z "${SMAGESCRIPTSDIR}" ]   else
226  then   # build md5sum for existing packages
227   die "\$SMAGESCRIPTSDIR not found. Please setup your mage.rc correctly."   generate_package_md5sum \
228  fi   --pcat "${PCAT}" \
229     --pname "${PNAME}" \
230     --pver "${PVER}" \
231     --pbuild "${PBUILD}" \
232     --parch "${ARCH}"
233     fi
234    
235  if [ -z "${SMAGE2RSYNC}" ]   exit 0
 then  
  echo "\$SMAGE2RSYNC not found. Please setup your mage.rc correctly."  
  exit 1  
236  fi  fi
237    
238  if [ -z "${BINDIR}" ]  if [ "$1" == "--create-src-tarball" -a -n "$2" ]
239  then  then
240   die "no BINDIR variable found in /etc/mage.rc"   # set correct SMAGENAME
241  fi   SMAGENAME="$2"
242     MD5DIR="$(dirname ${SMAGENAME})/md5"
243    
244  if [ -z "${CHOST}" ]   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
245  then  
246   die "no CHOST variable found in /etc/mage.rc"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
247    
248     if [[ -d ${SOURCEDIR}/${PNAME} ]]
249     then
250     echo -e "${COLGREEN}Deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
251     rm -rf ${SOURCEDIR}/${PKGNAME}
252     fi
253    
254     download_sources
255     source_pkg_build ${SMAGENAME}
256     exit 0
257  fi  fi
258    
259  if [ -z "${CFLAGS}" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
260  then  then
261   die "no CFLAGS variable found in /etc/mage.rc"   SRCPKGTARBALL="${2}"
262     msetfeature "srcpkgtarball"
263    
264     # abort if given file is not a source pkg
265     [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
266    
267     # set correct SMAGENAME; use the one that the src_pkg provide
268     # /path/to/SOURCEDIR/PNAME/SMAGENAME
269     SMAGENAME="${SOURCEDIR}/$(basename ${SRCPKGTARBALL%-*-*})/$(basename ${SRCPKGTARBALL} .${SRCPKGSUFFIX}).${SMAGESUFFIX}"
270    
271     echo -e "${COLGREEN}Using src-tarball ${COLBLUE}${SRCPKGTARBALL}${COLGREEN} ...${COLDEFAULT}"
272    
273     [[ ! -d ${SOURCEDIR} ]] && install -d ${SOURCEDIR}
274    
275     # unpack srctarball
276     [[ ! -f ${SRCPKGTARBALL} ]] && die "Error: ${SRCPKGTARBALL} does not exist. Aborting."
277    
278     tar xvjf ${SRCPKGTARBALL} -C ${SOURCEDIR} || die  "Error unpackung src-tarball ${SRCPKGTARBALL}"
279    
280     [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
281  fi  fi
282    
283  if [ -z "${CXXFLAGS}" ]  if [ "$1" == "--resume" -a -n "$2" ]
284  then  then
285   die "no CXXFLAGS variable found in /etc/mage.rc"   msetfeature "resume"
286     SMAGENAME="$2"
287  fi  fi
288    
289    [ ! -e ${MLIBDIR}/pkgbuild_dir ] && die "Error: ${MLIBDIR}/pkgbuild_dir not found. Aborting."
290    [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
291     die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
292    [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
293    [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your ${MAGERC} correctly."
294    [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your ${MAGERC} correctly."
295    [ -z "${BINDIR}" ] && die "no BINDIR variable found in ${MAGERC}"
296    [ -z "${CHOST}" ] && die "no CHOST variable found in ${MAGERC}"
297    [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
298    [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
299    
300  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
301  PKGNAME="${PNAME}-${PVER}-${CHOST%%-*}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
302  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
303    SMAGE_LOG_CMD="tee -a ${SMAGELOGDIR}/${PKGNAME}.log"
304    
305  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
306  echo "Compiling ${PKGNAME}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
307    
308  # auto regen mage tree if requested  if mqueryfeature "srcpkgbuild"
309  regen_mage_tree  then
310     if [[ -d ${SOURCEDIR}/${PNAME} ]]
311     then
312     echo -e "${COLBLUE}===${COLGREEN} deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
313     rm -rf ${SOURCEDIR}/${PNAME}
314     fi
315    fi
316    
317  # download sources  # download sources
318  download_sources  mqueryfeature "srcpkgtarball" || download_sources
319    
320  # fixes some issues with these functions  # fixes some issues with these functions
321    export -f pkg_setup || die "pkg_setup export failed"
322  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
323  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
324    export -f src_check || die "src_check export failed"
325  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
326    
327  # fixes some compile issues  # fixes some compile issues
328  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
329  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
330  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
331    then
332     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
333    else
334     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
335    fi
336    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
337  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
338  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
339    
   
340  # setup distcc  # setup distcc
341  # distcc mus be setup *before* ccache, as ccache need to be before distcc in path  # setup for distcc goes *before* ccache, so ccache comes before distcc in path
342  if [ "${SMAGE_USE_DISTCC}" == "true" ]  mqueryfeature "distcc" && setup_distcc_environment
343  then  
344   setup_distcc_environment  # setup icecc
345  fi  # setup for icecc goes *before* ccache, so ccache comes before icecc in path
346    mqueryfeature "icecc" && setup_icecc_environment
347    
348  # setup ccache  # setup ccache
349  if [ "${SMAGE_USE_CCACHE}" == "true" ]  mqueryfeature "ccache" && setup_ccache_environment
350    
351    if mqueryfeature "resume"
352  then  then
353   setup_ccache_environment   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
354  fi  
355     # setup build logging
356     [[ ! -d ${SMAGELOGDIR} ]] && install -d ${SMAGELOGDIR}
357     if [[ -f ${SMAGELOGDIR}/${PKGNAME}.log.bz2 ]]
358     then
359     bunzip2 -f ${SMAGELOGDIR}/${PKGNAME}.log.bz2
360     fi
361     echo -e "### Resume started on $(date) ###\n" >> ${SMAGELOGDIR}/${PKGNAME}.log
362    
363    else
364     # clean up builddir if a previously one exist
365     if [ -d ${BUILDDIR} ]
366     then
367     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
368     fi
369     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
370    
371     # clean up srcdir if a previously unpacked one exist
372     if [ -d ${SRCDIR} ]
373     then
374     rm -rf ${SRCDIR}
375     fi
376    
377  # small sleep to show our settings   # clean up bindir if a previous build exist or create a new one
378  sleep 1   if [ -d ${BINDIR} ]
379     then
380     rm -rf ${BINDIR}
381     fi
382     install -d ${BINDIR} || die "couldn't create \$BINDIR."
383    
384  #debug   # clean up package temp dir if a previous build exist
385  #echo "CC=${CC}"   if [ -d ${BUILDDIR}/${PKGNAME} ]
386  #echo "CXX=${CXX}"   then
387  #echo "DISTCC_DIR=${DISTCC_DIR}"   rm -rf ${BUILDDIR}/${PKGNAME}
388  #echo "PATH: ${PATH}"   fi
 #echo "--------------------------------------"  
 #env  
 #echo "--------------------------------------"  
 #read  
 #debug end  
389    
390  # cleans up build if a previously one exists   # clean up stamps dir
391  if [ -d ${BUILDDIR} ]   if [ -d ${BUILDDIR}/.stamps ]
392  then   then
393   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   rm -rf ${BUILDDIR}/.stamps
394     fi
395    
396     # setup build logging
397     [[ ! -d ${SMAGELOGDIR} ]] && install -d ${SMAGELOGDIR}
398     echo -e "### Build started on $(date) ###\n" > ${SMAGELOGDIR}/${PKGNAME}.log
399  fi  fi
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
400    
401  # cleans up srcdir if a previously unpacked one exists  if [[ ${PKGTYPE} = virtual ]]
 if [ -d ${SRCDIR} ]  
402  then  then
403   rm -rf ${SRCDIR}   echo "virtual package detected; nothing will be build ..."
404     # automatically set !pkgbuild here too
405     msetfeature "!pkgbuild"
406    else
407     ( run_resume pkg_setup || pkg_setup ) | ${SMAGE_LOG_CMD}
408     die_pipestatus 0 "pkg_setup failed"
409     resume_stamp pkg_setup
410     step_by_step pkg_setup
411    
412     ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
413     die_pipestatus 0 "src_prepare failed"
414     resume_stamp src_prepare
415     step_by_step src_prepare
416    
417     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
418     die_pipestatus 0 "src_compile failed"
419     resume_stamp src_compile
420     step_by_step src_compile
421    
422     # only run checks if requested
423     if mqueryfeature "!check"
424     then
425     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
426     else
427     ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
428     die_pipestatus 0 "src_check failed"
429     resume_stamp src_check
430     fi
431     step_by_step src_check
432    
433     # build several subpackages
434     if [[ -n ${SPLIT_PACKAGES} ]]
435     then
436     # save bindir & pname
437     split_save_variables
438     export SAVED_BINDIR="${BINDIR}"
439     for subpackage in ${SPLIT_PACKAGES}
440     do
441     split_info_${subpackage}
442     if [[ ${PKGTYPE} = virtual ]]
443     then
444     echo
445     echo -en "${COLBLUE}*** ${COLDEFAULT}"
446     echo -en "Virtual package detected"
447     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
448     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
449    
450     echo "virtual package detected; nothing will be build ..."
451     # automatically set !pkgbuild here too
452     msetfeature "!pkgbuild"
453     else
454     if typeset -f src_install_${subpackage} > /dev/null
455     then
456     # export subpackage bindir
457     export BINDIR="${SAVED_BINDIR}_${subpackage}"
458     # export PNAME, several internal function and include
459     # rely on this variable
460     export PNAME="${subpackage}"
461    
462     echo
463     echo -en "${COLBLUE}*** ${COLDEFAULT}"
464     echo -en "Running ${COLGREEN}split src_install()${COLDEFAULT}"
465     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
466     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
467    
468     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
469     die_pipestatus 0 "src_install_${subpackage} failed"
470     resume_stamp src_install_${subpackage}
471     step_by_step src_install_${subpackage}
472     fi
473     fi
474     # restore smage environment
475     split_restore_variables
476     done
477     # unset all saved smage variables
478     split_unset_variables
479     else
480     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
481     die_pipestatus 0 "src_install failed"
482     resume_stamp src_install
483     step_by_step src_install
484     fi
485  fi  fi
486    
487  # cleans up bindir if a previous build exists or creates a new one  # echo for sake of good-looking
488  if [ -d ${BINDIR} ]  echo
489    
490    if mqueryfeature "!compressdoc"
491    then
492     echo -e "!compressdoc detected; documentation will not be compressed ..."
493    elif mqueryfeature "!pkgbuild"
494  then  then
495   rm -rf ${BINDIR}   echo "!pkgbuild detected; skipping documentation compression..."
496    else
497     # compressing doc, info & man files
498     if [[ -n ${SPLIT_PACKAGES} ]]
499     then
500     # save smage environment
501     split_save_variables
502     for subpackage in ${SPLIT_PACKAGES}
503     do
504     # honor split_info
505     split_info_${subpackage}
506     if [[ ${PKGTYPE} = virtual ]]
507     then
508     # automatically set !pkgbuild here too
509     msetfeature "!pkgbuild"
510     fi
511    
512     if mqueryfeature "!compressdoc"
513     then
514     echo -e "!compressdoc detected; documentation of '${subpackage}' will not be compressed ..."
515     elif mqueryfeature "!pkgbuild"
516     then
517     echo "!pkgbuild detected; skipping documentation compression for '${subpackage}' ..."
518     else
519     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
520     resume_stamp post-mcompressdoc_${subpackage}
521     fi
522     # restore smage environment
523     split_restore_variables
524     done
525     # unset saved variables
526     split_unset_variables
527     else
528     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
529     resume_stamp post-mcompressdoc
530     fi
531  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
532    
533  # cleans up package temp dir if a previous build exists  if mqueryfeature "!libtool"
 if [ -d ${BUILDDIR}/${PKGNAME} ]  
534  then  then
535   rm -rf ${BUILDDIR}/${PKGNAME}   if mqueryfeature "!pkgbuild"
536     then
537     echo "!pkgbuild detected; skipping libtool archive stripping ..."
538     else
539     if [[ -n ${SPLIT_PACKAGES} ]]
540     then
541     # save smage environment
542     split_save_variables
543     for subpackage in ${SPLIT_PACKAGES}
544     do
545     # honor split_info
546     split_info_${subpackage}
547     if [[ ${PKGTYPE} = virtual ]]
548     then
549     # automatically set !pkgbuild here too
550     msetfeature "!pkgbuild"
551     fi
552    
553     if mqueryfeature "!libtool"
554     then
555     if mqueryfeature "!pkgbuild"
556     then
557     echo "!pkgbuild detected; skipping libtool archive stripping for '${subpackage}'..."
558     else
559     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
560     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
561     resume_stamp post-mstriplibtoolarchive_${subpackage}
562     fi
563     fi
564    
565     # restore smage environment
566     split_restore_variables
567     done
568     # unset saved variables
569     split_unset_variables
570     else
571     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
572     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
573     resume_stamp post-mstriplibtoolarchive
574     fi
575     fi
576  fi  fi
577    
578  # cleans up timestamp if one exists  if mqueryfeature "purge"
 if [ -f /var/tmp/timestamp ]  
579  then  then
580   mage rmstamp   if mqueryfeature "!pkgbuild"
581  fi   then
582     echo "!pkgbuild detected; skipping file purgation ..."
583     else
584     if [[ -n ${SPLIT_PACKAGES} ]]
585     then
586     # save smage environment
587     split_save_variables
588     for subpackage in ${SPLIT_PACKAGES}
589     do
590     # honor split_info
591     split_info_${subpackage}
592     if [[ ${PKGTYPE} = virtual ]]
593     then
594     # automatically set !pkgbuild here too
595     msetfeature "!pkgbuild"
596     fi
597    
598  src_prepare || die "src_prepare failed"   if mqueryfeature "purge"
599  src_compile || die "src_compile failed"   then
600  src_install || die "src_install failed"   if mqueryfeature "!pkgbuild"
601     then
602     echo "!pkgbuild detected; skipping file purgation for '${subpackage}' ..."
603     else
604     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
605     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
606     resume_stamp post-mpurgetargets_${subpackage}
607     fi
608     fi
609    
610     # restore smage environment
611     split_restore_variables
612     done
613     # unset saved variables
614     split_unset_variables
615     else
616     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
617     run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
618     resume_stamp post-mpurgetargets
619     fi
620     fi
621    fi
622    
623  # compressing doc, info & man files  # stripping all bins and libs
624  echo -e "Compressing man-pages ..."  if mqueryfeature "!strip"
625  if [ -d ${BUILDDIR}/builded/usr/share/man ]  then
626     echo -e "!strip detected; package will not be stripped ..."
627    elif mqueryfeature "!pkgbuild"
628  then  then
629   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   echo "!pkgbuild detected; skipping stripping of the package ..."
630    else
631     if [[ -n ${SPLIT_PACKAGES} ]]
632     then
633     # save smage environment
634     split_save_variables
635     for subpackage in ${SPLIT_PACKAGES}
636     do
637     # honor split_info
638     split_info_${subpackage}
639     if [[ ${PKGTYPE} = virtual ]]
640     then
641     # automatically set !pkgbuild here too
642     msetfeature "!pkgbuild"
643     fi
644    
645     if mqueryfeature "!strip"
646     then
647     echo -e "!strip detected; package '${subpackage}' will not be stripped ..."
648     elif mqueryfeature "!pkgbuild"
649     then
650     echo "!pkgbuild detected; skipping stripping of the package '${subpackage}' ..."
651     else
652     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
653     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
654     resume_stamp post-mstripbins_${subpackage}
655     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
656     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
657     resume_stamp post-mstriplibs_${subpackage}
658     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
659     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
660     resume_stamp post-mstripstatic_${subpackage}
661     fi
662    
663     # restore smage environment
664     split_restore_variables
665     done
666     # unset saved variables
667     split_unset_variables
668     else
669     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
670     run_resume post-mstripbins || mstripbins ${BINDIR}
671     resume_stamp post-mstripbins
672     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
673     run_resume post-mstriplibs || mstriplibs ${BINDIR}
674     resume_stamp post-mstriplibs
675     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
676     run_resume post-mstripstatic || mstripstatic ${BINDIR}
677     resume_stamp post-mstripstatic
678     fi
679  fi  fi
680    
681  echo -e "Compressing info-pages ..."  if mqueryfeature "qalint"
 if [ -d ${BUILDDIR}/builded/usr/share/info ]  
682  then  then
683   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   if mqueryfeature "!pkgbuild"
684     then
685     echo "!pkgbuild detected; skipping QA lint checks ..."
686     else
687     if [[ -n ${SPLIT_PACKAGES} ]]
688     then
689     # save smage environment
690     split_save_variables
691     for subpackage in ${SPLIT_PACKAGES}
692     do
693     # honor split_info
694     split_info_${subpackage}
695     if [[ ${PKGTYPE} = virtual ]]
696     then
697     # automatically set !pkgbuild here too
698     msetfeature "!pkgbuild"
699     fi
700    
701     if mqueryfeature "qalint"
702     then
703     if mqueryfeature "!pkgbuild"
704     then
705     echo "!pkgbuild detected; skipping QA lint checks for '${subpackage}' ..."
706     else
707     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks for '${subpackage}' ...${COLDEFAULT}"
708     mqalint ${BINDIR}_${subpackage}
709     fi
710     fi
711    
712     # restore smage environment
713     split_restore_variables
714     done
715     # unset saved variables
716     split_unset_variables
717     else
718     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks ...${COLDEFAULT}"
719     mqalint ${BINDIR}
720     fi
721     fi
722  fi  fi
723    
724  # stripping all bins and libs  if mqueryfeature "!pkgbuild"
725  case ${NOSTRIP} in  then
726   true|TRUE|yes|y)   echo -e "!pkgbuild detected; Package will not be build ..."
727   echo -e "NOSTRIP=true detected; Package will not be stripped ..."  else
728   ;;   # build several subpackages
729   *)   if [[ -n ${SPLIT_PACKAGES} ]]
  echo -e "Stripping binaries ..."  
  mstripbins ${BINDIR}  
  echo -e "Stripping libraries ..."  
  mstriplibs ${BINDIR}  
  ;;  
 esac  
   
 # the new buildpkg command  
 case ${NOPKGBUILD} in  
  true|TRUE|yes|y)  
  echo -e "NOPGKBUILD=true detected; Package will not be build ..."  
  ;;  
  *)  
  # build serveral targets  
  if [ -n "${MAGE_TARGETS}" ]  
730   then   then
731   for target in ${MAGE_TARGETS}   split_save_variables
732     for subpackage in ${SPLIT_PACKAGES}
733   do   do
734   # check if an special target_pkgbuild exists   # get the right variables for the split
735   if typeset -f ${target}_pkgbuild > /dev/null   export PNAME="${subpackage}"
736     split_info_${PNAME}
737     # fix PCATEGORIE -> PCAT
738     if [[ ! -z ${PCATEGORIE} ]]
739     then
740     PCAT="${PCATEGORIE}"
741     unset PCATEGORIE
742     fi
743     if [[ ${PKGTYPE} = virtual ]]
744     then
745     # automatically set !pkgbuild here too
746     msetfeature "!pkgbuild"
747     fi
748    
749     # jump to next one if !pkgbuild is set in split_info
750     if mqueryfeature "!pkgbuild"
751     then
752     # restore smage environment
753     split_restore_variables
754     continue
755     fi
756    
757     # check if an special subpackage_pkgbuild exists
758     if typeset -f ${PNAME}_pkgbuild > /dev/null
759   then   then
760   # run it   # run it
761   ${target}_pkgbuild   run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
762     resume_stamp post-${PNAME}_pkgbuild
763   fi   fi
764   # now create the target package   # now create the target package
765   ${MLIBDIR}/pkgbuild_dir.sh \   run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir \
766   "${PNAME}-${target}-${PVER}-${CHOST%%-*}-${PBUILD}" \   "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
767   ${BINDIR} || die "target: ${target} package-build failed"   "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
768   echo -e "\nPackage ${PNAME}-${target}-${PVER}-${CHOST%%-*}-${PBUILD} successfully builded.\n"   resume_stamp post-pkg_builddir_${PNAME}
769    
770     # build pkg-md5-sum if requested
771     run_resume post-md5sum_${PNAME} || generate_package_md5sum \
772     --pcat "${PCAT}" \
773     --pname "${PNAME}" \
774     --pver "${PVER}" \
775     --pbuild "${PBUILD}" \
776     --parch "${ARCH}"
777     resume_stamp post-md5sum_${PNAME}
778    
779     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
780    
781     # restore smage environment
782     split_restore_variables
783   done   done
784     # unset all saved smage variables
785     split_unset_variables
786    
787   else   else
788   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir ${PKGNAME} ${BINDIR} || die "package-build failed"
789   echo -e "\nPackage ${PKGNAME} successfully builded.\n"   resume_stamp post-pkg_builddir
790    
791     # build pkg-md5-sum if requested
792     run_resume post-md5sum || generate_package_md5sum \
793     --pcat "${PCAT}" \
794     --pname "${PNAME}" \
795     --pver "${PVER}" \
796     --pbuild "${PBUILD}" \
797     --parch "${ARCH}"
798     resume_stamp post-md5sum
799    
800     echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
801   fi   fi
  ;;  
 esac  
802    
803  # for sure   # build src-pkg-tarball if requested
804  unset NOPKGBUILD   if mqueryfeature "srcpkgbuild"
805  unset NOSTRIP   then
806     run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
807     resume_stamp post-srcpkgbuild
808     fi
809    fi
810    
811    # auto regen mage tree if requested
812    regen_mage_tree
813    
814    if mqueryfeature "buildlog"
815    then
816     bzip2 -9f ${SMAGELOGDIR}/${PKGNAME}.log
817    else
818     [[ -f ${SMAGELOGDIR}/${PKGNAME}.log ]] && rm ${SMAGELOGDIR}/${PKGNAME}.log
819    fi
820    
821  xtitleclean  xtitleclean
 #echo -e "\nPackage ${PKGNAME} successfully builded.\n"  

Legend:
Removed from v.195  
changed lines
  Added in v.2806